﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectCar1
{
    public enum DirectionType
    {
        Up = 1,
        Down = 2,
        Left = 3,
        Right = 4,
    }

    public class DrawningSportCar
    {
        public EntitySportCar? EntitySportCar { get; private set; }

        private int _pictureWidth;

        private int _pictureHeight;

        private int _startPosX;

        private int _startPosY;

        private readonly int _carWidth = 110;

        private readonly int _carHeight = 60;
        public bool Init(int speed, double weight, Color bodyColor, Color additionalColor, bool bodyKit, bool wing, bool sportLine, int width, int height)
        {
            _pictureWidth = width;
            _pictureHeight = height;
            EntitySportCar = new EntitySportCar();
            EntitySportCar.Init(speed, weight, bodyColor, additionalColor,
            bodyKit, wing, sportLine);
            return true;
        }

        public void SetPosition(int x, int y)
        {
            // TODO: Изменение x, y
            _startPosX = x;
            _startPosY = y;
        }

        public void MoveTransport(DirectionType direction)
        {
            if (EntitySportCar == null)
            {
                return;
            }
            switch (direction)
            {
                case DirectionType.Left:
                    if (_startPosX - EntitySportCar.Step > 0)
                    {
                        _startPosX -= (int)EntitySportCar.Step;
                    }
                    break;
                //вверх
                case DirectionType.Up:
                    if (_startPosY - EntitySportCar.Step > 0)
                    {
                        _startPosY -= (int)EntitySportCar.Step;
                    }
                    break;
                // вправо
                case DirectionType.Right:
                    if (_startPosX - EntitySportCar.Step > 0)
                    {
                        _startPosX += (int)EntitySportCar.Step;
                    }
                    break;
                //вниз
                case DirectionType.Down:
                    if (_startPosY - EntitySportCar.Step > 0)
                    {
                        _startPosY += (int)EntitySportCar.Step;
                    }
                    break;
            }
        }

        public void DrawTransport(Graphics g)
        {
            if (EntitySportCar == null)
            {
                return;
            }
            Pen pen = new(Color.Black);
            

            if (EntitySportCar.BodyKit)
            {
                

                Brush additionalBrush = new
                SolidBrush(EntitySportCar.AdditionalColor);
                Rectangle rect = new Rectangle(_startPosX + 10, _startPosY + 30, 120, 20);
                g.FillRectangle(additionalBrush,rect);
                Rectangle rect1 = new Rectangle(_startPosX + 10, _startPosY + 10, 40, 20);
                g.FillRectangle(additionalBrush, rect1);

                int step = 15;
                for(int i = 0; i < 6; i++) 
                {
                    rect = new Rectangle(_startPosX + i * step, _startPosY + 100, 10, 30);
                    g.DrawEllipse(pen, _startPosX + 10, _startPosY + 50, 20, 20);
                    g.DrawEllipse(pen, _startPosX + 30, _startPosY + 50, 20, 20);
                    g.DrawEllipse(pen, _startPosX + 90, _startPosY + 50, 20, 20);
                    g.DrawEllipse(pen, _startPosX + 110, _startPosY + 50, 20, 20);
                }    
            }
        }
    }
}
