namespace ProjectCar1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private DrawningSportCar? drawningSportCar;

        private void Draw()
        {
            if (drawningSportCar == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBox1.Width, pictureBox1.Height);
            Graphics gr = Graphics.FromImage(bmp);
            drawningSportCar.DrawTransport(gr);
            pictureBox1.Image = bmp;
        }

        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (drawningSportCar == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    drawningSportCar.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    drawningSportCar.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    drawningSportCar.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    drawningSportCar.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();

        }

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            drawningSportCar = new DrawningSportCar();
            drawningSportCar.Init(random.Next(100, 300), random.Next(1000, 3000), Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)),
            pictureBox1.Width, pictureBox1.Height);
            drawningSportCar.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();

        }

        private void InitializeComponent()
        {
            pictureBox1 = new PictureBox();
            buttonUp = new Button();
            buttonDown = new Button();
            buttonLeft = new Button();
            buttonRight = new Button();
            buttonCreate = new Button();
            ((System.ComponentModel.ISupportInitialize)pictureBox1).BeginInit();
            SuspendLayout();
            // 
            // pictureBox1
            // 
            pictureBox1.BackColor = SystemColors.Window;
            pictureBox1.Dock = DockStyle.Fill;
            pictureBox1.Location = new Point(0, 0);
            pictureBox1.Name = "pictureBox1";
            pictureBox1.Size = new Size(1004, 559);
            pictureBox1.TabIndex = 0;
            pictureBox1.TabStop = false;
            pictureBox1.Click += buttonMove_Click;
            // 
            // buttonUp
            // 
            buttonUp.Location = new Point(926, 495);
            buttonUp.Name = "buttonUp";
            buttonUp.Size = new Size(30, 23);
            buttonUp.TabIndex = 1;
            buttonUp.Text = "^";
            buttonUp.UseVisualStyleBackColor = true;
            buttonUp.Click += buttonMove_Click;
            // 
            // buttonDown
            // 
            buttonDown.Location = new Point(926, 524);
            buttonDown.Name = "buttonDown";
            buttonDown.Size = new Size(30, 23);
            buttonDown.TabIndex = 2;
            buttonDown.Text = "_";
            buttonDown.UseVisualStyleBackColor = true;
            buttonDown.Click += buttonMove_Click;
            // 
            // buttonLeft
            // 
            buttonLeft.Location = new Point(890, 525);
            buttonLeft.Name = "buttonLeft";
            buttonLeft.Size = new Size(30, 23);
            buttonLeft.TabIndex = 3;
            buttonLeft.Text = "<";
            buttonLeft.UseVisualStyleBackColor = true;
            buttonLeft.Click += buttonMove_Click;
            // 
            // buttonRight
            // 
            buttonRight.Location = new Point(962, 525);
            buttonRight.Name = "buttonRight";
            buttonRight.Size = new Size(30, 22);
            buttonRight.TabIndex = 4;
            buttonRight.Text = ">";
            buttonRight.UseVisualStyleBackColor = true;
            buttonRight.Click += buttonMove_Click;
            // 
            // buttonCreate
            // 
            buttonCreate.Location = new Point(12, 525);
            buttonCreate.Name = "buttonCreate";
            buttonCreate.Size = new Size(75, 23);
            buttonCreate.TabIndex = 5;
            buttonCreate.Text = "";
            buttonCreate.UseVisualStyleBackColor = true;
            buttonCreate.Click += buttonCreate_Click;
            // 
            // Form1
            // 
            ClientSize = new Size(1004, 559);
            Controls.Add(buttonCreate);
            Controls.Add(buttonRight);
            Controls.Add(buttonLeft);
            Controls.Add(buttonDown);
            Controls.Add(buttonUp);
            Controls.Add(pictureBox1);
            Name = "Form1";
            ((System.ComponentModel.ISupportInitialize)pictureBox1).EndInit();
            ResumeLayout(false);
        }
    }
}